CREATE TABLE dspam_token_data (
  uid smallint,
  token numeric(20),
  spam_hits int,
  innocent_hits int,
  last_hit date,
  UNIQUE (token, uid)
);

CREATE INDEX id_token_data_01 ON dspam_token_data(innocent_hits);

CREATE TABLE dspam_signature_data (
  uid smallint,
  signature varchar(128),
  data bytea,
  length smallint,
  created_on date,
  UNIQUE (signature, uid)
);

CREATE TABLE dspam_stats (
  uid smallint PRIMARY KEY,
  spam_learned int,
  innocent_learned int,
  spam_misclassified int,
  innocent_misclassified int,
  spam_corpusfed int,
  innocent_corpusfed int,
  spam_classified int,
  innocent_classified int
);

CREATE TABLE dspam_neural_data (
  uid smallint,
  node smallint,
  total_correct int,
  total_incorrect int,
  UNIQUE (node, uid)
);

CREATE INDEX id_neural_data_01 ON dspam_neural_data(uid);

CREATE TABLE dspam_neural_decisions (
  uid smallint,
  signature varchar(128),
  data bytea,
  length smallint,
  created_on date,
  UNIQUE (signature, uid)
);
